<?php
/*
* Pixel Point Creative "Swift Slides Pro" Module for Joomla!
* License: GNU General Public License version 2
* See: http://www.gnu.org/copyleft/gpl.html
* Copyright (c) Pixel Point Creative LLC.
* More info at http://www.pixelpointcreative.com
* Review our terms/license here: http://pixelpointcreative.com/terms.html
*/
// no direct access
defined('_JEXEC') or die('Restricted access');
defined('_TOOLS') or die;
if (!class_exists('Reader')){
	abstract class Reader {
		protected static $components = array();
		abstract function getList(&$params);
		public function __get($component){
			if (!isset(self::$components[$component])){
				include_once dirname(__FILE__) . DS . 'components' . DS . 'abstract.php';
				$sj_components_class = dirname(__FILE__) . DS . 'components' . DS . $component . '.php';
				if (file_exists($sj_components_class)){
					include_once $sj_components_class;
					// create new instance
					$class_name = ucfirst($component) . 'Reader';
					self::$components[$component] = new $class_name();
					// return self::$components[$component];
				} else {
					// echo "<pre>$component reader does not exists!</pre>";
				}
			}
			return self::$components[$component];
		}
		public function getItem($id){
			$item = null;
			if ( !isset($this->_items[$id]) ){
				$this->_getItemsFromDb($id);
			}
			$item = &$this->_items[$id];
			return $item;
		}
		public function getItems($ids){
			$list = array();
			if ( is_string($ids) ){
				$ids = explode(',', $ids);
			}
			if ( is_array($ids) ){
				array_map('intval', $ids);
				$ids = array_unique($ids);
				$missing = array();
				foreach ($ids as $id) {
					if (!isset($this->_items[$id])){
						$missing[$id] = $id;
					}
				}
				$this->_getItemsFromDb($missing);
				foreach ($ids as $id){
					$list[$id] = &$this->_items[$id];
				}
			}
			return $list;
		}
		public function getCategory($cid){
			$category = null;
			if ( !isset($this->_categories[$cid]) ){
				$this->_getCategoriesFromDb($cid);
			}
			$category = &$this->_categories[$cid];
			return $category;
		}
		public function getCategories($cids){
			$list = array();
			if ( is_string($cids) ){
				$cids = explode(',', $cids);
			}
			if ( is_array($cids) ){
				array_map('intval', $cids);
				$cids = array_unique($cids);
				$missing = array();
				foreach ($cids as $cid) {
					if (!isset($this->_categories[$cid])){
						$missing[$cid] = $cid;
					}
				}
				$this->_getCategoriesFromDb($missing);
				foreach ($cids as $cid){
					$list[$cid] = &$this->_categories[$cid];
				}
			}
			return $list;
		}
	}
}