<?php
/*
* Pixel Point Creative "Swift Slides Pro" Module for Joomla!
* License: GNU General Public License version 2
* See: http://www.gnu.org/copyleft/gpl.html
* Copyright (c) Pixel Point Creative LLC.
* More info at http://www.pixelpointcreative.com
* Review our terms/license here: http://pixelpointcreative.com/terms.html
*/
// no direct access
defined('_JEXEC') or die('Restricted access');
class JFormFieldCustom extends JFormField{
	
	public function getLabel(){
		// Initialise variables.
		$label = '';
		if ($this->hidden) {
			return $label;
		}
		// Get the label text from the XML element, defaulting to the element name.
		$text = $this->element['label'] ? (string) $this->element['label'] : (string) $this->element['name'];
		$text = $this->translateLabel ? JText::_($text) : $text;
		// Build the class for the label.
		$class = !empty($this->description) ? 'hasTip' : '';
		$class = $this->required == true ? $class.' required' : $class;
		// Add the opening label tag and main attributes attributes.
		$label .= '<label id="'.$this->id.'-lbl" class="'.$class.'"';
		// If a description is specified, use it to build a tooltip.
		if (!empty($this->description)) {
			$label .= ' title="'.htmlspecialchars(trim($text, ':').'::' .
				($this->translateDescription ? JText::_($this->description) : $this->description), ENT_COMPAT, 'UTF-8').'"';
		}
		// Add the label text and closing tag.
		if ($this->required) {
			$label .= '>'.$text.'<span class="star">&#160;*</span></label>';
		} else {
			$label .= '>'.$text.'</label>';
		}
		return $label;
	}
	
	public function  getInput(){
		$this->defaults = $this->getFields();
		$key = null;
		foreach($this->defaults as $field0 => $value){
			$key = $field0;
			break;
		}
		
		$hasData = is_array($this->value) && count($this->value);
		$html = array();
		$html[] = '<div class="sj-custom" style="border:1px solid #c0c0c0; clear: both;padding: 5px 0;">';
		// $html[] = YTools::dump($this->value, '', false);
		if ($hasData){
			$this->_index = 0;
			foreach ($this->value as $item) {
				if (!$this->is_valid($item)){
					continue;
				}
					
				$item_css = '';
				if (isset($item->$key)){
					$item_css .= 'item-' . $item->$key;
				}
				if ($this->_index % 2 == 0){
					$item_css .= ' even';
				} else {
					$item_css .= ' odd';
				}
				
				$html[] = $this->item_block($item, $item_css);
				$this->_index++;
			}
		}
		$html[] = $this->item_block($this->defaults,'');
		
			$html[] = '<div class="item last">';
				$html[] = '<div class="item-field">';
					$html[] = '<div class="item-field-label">&nbsp;</div>';
					$html[] = '<div class="item-field-input">';
						$html[] = '<div class="item-add-button">';
							$html[] = '<a href="#"><span>ADD ITEM</span></a>';
						$html[] = '</div>';
					$html[] = '</div>';
				$html[] = '</div>';
				$html[] = '<div class="item-separator"></div>';
			$html[] = '</div>';
		$html[] = '</div>';
		$this->addStylesheet();
		
		return implode("\n", $html);
	}
	
	protected function is_valid($item){
		foreach($this->defaults as $field => $val){
			if (!property_exists($item, $field)){
				return false;
			}
		}
		return true;
	}
	
	protected function item_block($fields, $class_suffix){
		$html = array();
		
		$html[] = '<div class="item ' . $class_suffix . '">';
		foreach ($fields as $field => $value){
			$field = strtolower($field);
			if ((is_array($this->defaults) && !in_array($field, $this->defaults)) || (is_object($this->defaults) && !property_exists($this->defaults, $field))){
				continue;
			}
			$html[] = '<div class="item-field">';
				$html[] = '<div class="item-field-label">' . JText::_($field) . '</div>';
				$html[] = '<div class="item-field-input item-field-' . $field . '">';
				if ($field=='description'){
					//$html[] = '<input value="' . $value . '" name="' . $this->name . "[{$this->_index}][$field]" . '" />';
					$html[] = '<textarea rows="3" name="' . $this->name . "[{$this->_index}][$field]" . '">' . $value . '</textarea>';
				} else {
					$html[] = '<input value="' . $value . '" name="' . $this->name . "[{$this->_index}][$field]" . '" />';
				}
				$html[] = '</div>';
			$html[] = '</div>';
		}
			$html[] = '<div class="item-separator"></div>';
		$html[] = '</div>';
		
		return implode("\n", $html);
	}
	
	protected function getFields(){
		$fields = (string)$this->element['fields'];
		if (isset($this->element['fields']) && !empty($fields)){
			$fields = explode(',', $fields);
			if (count($fields)){
				$carryObject = new stdClass();
				foreach ($fields as $field) {
					$field = trim($field);
					$field = strtolower($field);
					if (!property_exists($carryObject, $field)){
						$carryObject->$field = '';
					}
				}
				return $carryObject;
			}
		}
		return array('id' => '', 'title' => '', 'image' => '', 'url' => '', 'description' => '');
	}
	
	protected function addStylesheet(){
		$document = &JFactory::getDocument();
		$document->addStyleDeclaration("
				.sj-custom .item{
					padding:0 5px;
				}
				.sj-custom .item-field{
					clear:both;
					padding: 0 0 5px 0;
				}
				.sj-custom .item-field-label{
					width: 25%;
					float: left;
				}
				.sj-custom .item-field-input{
					width: 74%;
					float: left;
				}
				.sj-custom .item-field-input input,
				.sj-custom .item-field-input textarea{
					margin: 0;
					width: 90%;
				}
				
				.sj-custom .item-separator{
					clear:both;
					height: 5px;
					border-top: dashed 1px #ddd;
				}
				
				.sj-custom .item-add-button{
					text-align: right;
					width: 90%;
				}
				
				.sj-custom .item-add-button a{
					font-weight: 700;
					
				}
								
				.sj-custom .item-field:after {
					content: '.';
					display: block;
					height: 0;
					clear: both;
					visibility: hidden;
					overflow: hidden;
				}
				.sj-custom .item-field {
					display: block;
				}
		");
		
		
	}
	
}
